"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.$password = exports.$random = exports.$hashfile = exports.$uuidhash = exports.$hash = exports.$crc32 = exports.$crc16 = exports.$decrypt = exports.$encrypt = exports.$commonInitializationVectorCopy = exports.$setCommonItializationVector = exports.AES256 = exports.AES128 = exports.SHA1 = exports.MD5 = exports.SHA512 = exports.SHA384 = exports.SHA256 = exports.$uuidVersion = exports.$uuid = void 0;
const fs_1 = require("fs");
const crypto = __importStar(require("crypto"));
const types_1 = require("./types");
const commons_1 = require("./commons");
const data_1 = require("./data");
const tscharset_1 = require("./tscharset");
const tsdata_1 = require("./tsdata");
const utils_1 = require("./utils");
const strings_1 = require("./strings");
function $uuid(internalImplementation = false) {
    if (!internalImplementation) {
        try {
            return crypto.randomUUID();
        }
        catch (_a) {
            (0, utils_1.$logterm)('Warning:crypto.randomUUID() is not available');
        }
    }
    return _generateV4UUID(true);
}
exports.$uuid = $uuid;
function $uuidVersion(str) {
    const s = (0, strings_1.$ftrim)(str);
    if (!s.length) {
        return undefined;
    }
    if (types_1.uuidV4Regex.test(s)) {
        return types_1.UUIDv4;
    }
    if (types_1.uuidV1Regex.test(s)) {
        return types_1.UUIDv1;
    }
    return undefined;
}
exports.$uuidVersion = $uuidVersion;
exports.SHA256 = 'SHA256';
exports.SHA384 = 'SHA384';
exports.SHA512 = 'SHA512';
exports.MD5 = 'MD5';
exports.SHA1 = 'SHA1';
exports.AES128 = 'AES128';
exports.AES256 = 'AES256';
const __TSNoSpecificIV = Buffer.from([3, 67, 0, 14, 2, 95, 191, 0, 217, 255, 7, 6, 1, 67, 13, 89]);
let __CommonInitializationVector = __TSNoSpecificIV;
function $setCommonItializationVector(d) { __CommonInitializationVector = (0, commons_1.$length)(d) === 16 ? (0, data_1.$bufferFromDataLike)(d) : __TSNoSpecificIV; }
exports.$setCommonItializationVector = $setCommonItializationVector;
function $commonInitializationVectorCopy() { return (0, data_1.$bufferFromBytes)(__CommonInitializationVector, { forceCopy: true }); }
exports.$commonInitializationVectorCopy = $commonInitializationVectorCopy;
function $encrypt(ssource, skey, opts) {
    const [charset, key, algo] = _charsetKeyAndAlgo(skey, opts);
    if (!charset) {
        return null;
    }
    const source = (0, commons_1.$isstring)(ssource) ? charset.uint8ArrayFromString(ssource) : (0, data_1.$uint8ArrayFromDataLike)(ssource);
    if (!(0, commons_1.$length)(source)) {
        return null;
    }
    let returnValue = null;
    try {
        const addIV = !(opts === null || opts === void 0 ? void 0 : opts.noInitializationVector);
        const iv = addIV ? crypto.randomBytes(16) : __CommonInitializationVector;
        const cipher = crypto.createCipheriv(algo, key, iv);
        let encrypted = addIV ? new tsdata_1.TSData(iv) : new tsdata_1.TSData();
        encrypted.appendBytes(cipher.update(source));
        encrypted.appendBytes(cipher.final());
        returnValue = !(opts === null || opts === void 0 ? void 0 : opts.dataOutput) ? encrypted.toString('hex') : encrypted;
    }
    catch (e) {
        console.log(e);
        returnValue = null;
    }
    return returnValue;
}
exports.$encrypt = $encrypt;
function $decrypt(source, skey, opts) {
    if (!(0, commons_1.$length)(source)) {
        return null;
    }
    const [charset, key, algo] = _charsetKeyAndAlgo(skey, opts);
    if (!charset) {
        return null;
    }
    let returnValue = null;
    try {
        const hasVector = !(opts === null || opts === void 0 ? void 0 : opts.noInitializationVector);
        let src;
        let iv;
        if ((0, commons_1.$isstring)(source)) {
            src = Buffer.from(hasVector ? source.slice(32) : source, 'hex');
            iv = hasVector ? Buffer.from(source.slice(0, 32), 'hex') : __CommonInitializationVector;
        }
        else {
            src = (0, data_1.$bufferFromDataLike)(source, { start: hasVector ? 16 : 0 });
            iv = hasVector ? (0, data_1.$bufferFromDataLike)(source, { end: 16 }) : __CommonInitializationVector;
        }
        let decipher = crypto.createDecipheriv(algo, key, iv);
        let decrypted = new tsdata_1.TSData(decipher.update(src));
        decrypted.appendBytes(decipher.final());
        returnValue = !(opts === null || opts === void 0 ? void 0 : opts.dataOutput) ? decrypted.toString(charset) : decrypted;
    }
    catch (e) {
        returnValue = null;
    }
    return returnValue;
}
exports.$decrypt = $decrypt;
const __crcTable16 = [
    0x0000, 0xc0c1, 0xc181, 0x0140, 0xc301, 0x03c0, 0x0280, 0xc241,
    0xc601, 0x06c0, 0x0780, 0xc741, 0x0500, 0xc5c1, 0xc481, 0x0440,
    0xcc01, 0x0cc0, 0x0d80, 0xcd41, 0x0f00, 0xcfc1, 0xce81, 0x0e40,
    0x0a00, 0xcac1, 0xcb81, 0x0b40, 0xc901, 0x09c0, 0x0880, 0xc841,
    0xd801, 0x18c0, 0x1980, 0xd941, 0x1b00, 0xdbc1, 0xda81, 0x1a40,
    0x1e00, 0xdec1, 0xdf81, 0x1f40, 0xdd01, 0x1dc0, 0x1c80, 0xdc41,
    0x1400, 0xd4c1, 0xd581, 0x1540, 0xd701, 0x17c0, 0x1680, 0xd641,
    0xd201, 0x12c0, 0x1380, 0xd341, 0x1100, 0xd1c1, 0xd081, 0x1040,
    0xf001, 0x30c0, 0x3180, 0xf141, 0x3300, 0xf3c1, 0xf281, 0x3240,
    0x3600, 0xf6c1, 0xf781, 0x3740, 0xf501, 0x35c0, 0x3480, 0xf441,
    0x3c00, 0xfcc1, 0xfd81, 0x3d40, 0xff01, 0x3fc0, 0x3e80, 0xfe41,
    0xfa01, 0x3ac0, 0x3b80, 0xfb41, 0x3900, 0xf9c1, 0xf881, 0x3840,
    0x2800, 0xe8c1, 0xe981, 0x2940, 0xeb01, 0x2bc0, 0x2a80, 0xea41,
    0xee01, 0x2ec0, 0x2f80, 0xef41, 0x2d00, 0xedc1, 0xec81, 0x2c40,
    0xe401, 0x24c0, 0x2580, 0xe541, 0x2700, 0xe7c1, 0xe681, 0x2640,
    0x2200, 0xe2c1, 0xe381, 0x2340, 0xe101, 0x21c0, 0x2080, 0xe041,
    0xa001, 0x60c0, 0x6180, 0xa141, 0x6300, 0xa3c1, 0xa281, 0x6240,
    0x6600, 0xa6c1, 0xa781, 0x6740, 0xa501, 0x65c0, 0x6480, 0xa441,
    0x6c00, 0xacc1, 0xad81, 0x6d40, 0xaf01, 0x6fc0, 0x6e80, 0xae41,
    0xaa01, 0x6ac0, 0x6b80, 0xab41, 0x6900, 0xa9c1, 0xa881, 0x6840,
    0x7800, 0xb8c1, 0xb981, 0x7940, 0xbb01, 0x7bc0, 0x7a80, 0xba41,
    0xbe01, 0x7ec0, 0x7f80, 0xbf41, 0x7d00, 0xbdc1, 0xbc81, 0x7c40,
    0xb401, 0x74c0, 0x7580, 0xb541, 0x7700, 0xb7c1, 0xb681, 0x7640,
    0x7200, 0xb2c1, 0xb381, 0x7340, 0xb101, 0x71c0, 0x7080, 0xb041,
    0x5000, 0x90c1, 0x9181, 0x5140, 0x9301, 0x53c0, 0x5280, 0x9241,
    0x9601, 0x56c0, 0x5780, 0x9741, 0x5500, 0x95c1, 0x9481, 0x5440,
    0x9c01, 0x5cc0, 0x5d80, 0x9d41, 0x5f00, 0x9fc1, 0x9e81, 0x5e40,
    0x5a00, 0x9ac1, 0x9b81, 0x5b40, 0x9901, 0x59c0, 0x5880, 0x9841,
    0x8801, 0x48c0, 0x4980, 0x8941, 0x4b00, 0x8bc1, 0x8a81, 0x4a40,
    0x4e00, 0x8ec1, 0x8f81, 0x4f40, 0x8d01, 0x4dc0, 0x4c80, 0x8c41,
    0x4400, 0x84c1, 0x8581, 0x4540, 0x8701, 0x47c0, 0x4680, 0x8641,
    0x8201, 0x42c0, 0x4380, 0x8341, 0x4100, 0x81c1, 0x8081, 0x4040
];
const __crcTable32 = [
    0x00000000, 0x77073096, 0xee0e612c, 0x990951ba, 0x076dc419, 0x706af48f, 0xe963a535, 0x9e6495a3,
    0x0edb8832, 0x79dcb8a4, 0xe0d5e91e, 0x97d2d988, 0x09b64c2b, 0x7eb17cbd, 0xe7b82d07, 0x90bf1d91,
    0x1db71064, 0x6ab020f2, 0xf3b97148, 0x84be41de, 0x1adad47d, 0x6ddde4eb, 0xf4d4b551, 0x83d385c7,
    0x136c9856, 0x646ba8c0, 0xfd62f97a, 0x8a65c9ec, 0x14015c4f, 0x63066cd9, 0xfa0f3d63, 0x8d080df5,
    0x3b6e20c8, 0x4c69105e, 0xd56041e4, 0xa2677172, 0x3c03e4d1, 0x4b04d447, 0xd20d85fd, 0xa50ab56b,
    0x35b5a8fa, 0x42b2986c, 0xdbbbc9d6, 0xacbcf940, 0x32d86ce3, 0x45df5c75, 0xdcd60dcf, 0xabd13d59,
    0x26d930ac, 0x51de003a, 0xc8d75180, 0xbfd06116, 0x21b4f4b5, 0x56b3c423, 0xcfba9599, 0xb8bda50f,
    0x2802b89e, 0x5f058808, 0xc60cd9b2, 0xb10be924, 0x2f6f7c87, 0x58684c11, 0xc1611dab, 0xb6662d3d,
    0x76dc4190, 0x01db7106, 0x98d220bc, 0xefd5102a, 0x71b18589, 0x06b6b51f, 0x9fbfe4a5, 0xe8b8d433,
    0x7807c9a2, 0x0f00f934, 0x9609a88e, 0xe10e9818, 0x7f6a0dbb, 0x086d3d2d, 0x91646c97, 0xe6635c01,
    0x6b6b51f4, 0x1c6c6162, 0x856530d8, 0xf262004e, 0x6c0695ed, 0x1b01a57b, 0x8208f4c1, 0xf50fc457,
    0x65b0d9c6, 0x12b7e950, 0x8bbeb8ea, 0xfcb9887c, 0x62dd1ddf, 0x15da2d49, 0x8cd37cf3, 0xfbd44c65,
    0x4db26158, 0x3ab551ce, 0xa3bc0074, 0xd4bb30e2, 0x4adfa541, 0x3dd895d7, 0xa4d1c46d, 0xd3d6f4fb,
    0x4369e96a, 0x346ed9fc, 0xad678846, 0xda60b8d0, 0x44042d73, 0x33031de5, 0xaa0a4c5f, 0xdd0d7cc9,
    0x5005713c, 0x270241aa, 0xbe0b1010, 0xc90c2086, 0x5768b525, 0x206f85b3, 0xb966d409, 0xce61e49f,
    0x5edef90e, 0x29d9c998, 0xb0d09822, 0xc7d7a8b4, 0x59b33d17, 0x2eb40d81, 0xb7bd5c3b, 0xc0ba6cad,
    0xedb88320, 0x9abfb3b6, 0x03b6e20c, 0x74b1d29a, 0xead54739, 0x9dd277af, 0x04db2615, 0x73dc1683,
    0xe3630b12, 0x94643b84, 0x0d6d6a3e, 0x7a6a5aa8, 0xe40ecf0b, 0x9309ff9d, 0x0a00ae27, 0x7d079eb1,
    0xf00f9344, 0x8708a3d2, 0x1e01f268, 0x6906c2fe, 0xf762575d, 0x806567cb, 0x196c3671, 0x6e6b06e7,
    0xfed41b76, 0x89d32be0, 0x10da7a5a, 0x67dd4acc, 0xf9b9df6f, 0x8ebeeff9, 0x17b7be43, 0x60b08ed5,
    0xd6d6a3e8, 0xa1d1937e, 0x38d8c2c4, 0x4fdff252, 0xd1bb67f1, 0xa6bc5767, 0x3fb506dd, 0x48b2364b,
    0xd80d2bda, 0xaf0a1b4c, 0x36034af6, 0x41047a60, 0xdf60efc3, 0xa867df55, 0x316e8eef, 0x4669be79,
    0xcb61b38c, 0xbc66831a, 0x256fd2a0, 0x5268e236, 0xcc0c7795, 0xbb0b4703, 0x220216b9, 0x5505262f,
    0xc5ba3bbe, 0xb2bd0b28, 0x2bb45a92, 0x5cb36a04, 0xc2d7ffa7, 0xb5d0cf31, 0x2cd99e8b, 0x5bdeae1d,
    0x9b64c2b0, 0xec63f226, 0x756aa39c, 0x026d930a, 0x9c0906a9, 0xeb0e363f, 0x72076785, 0x05005713,
    0x95bf4a82, 0xe2b87a14, 0x7bb12bae, 0x0cb61b38, 0x92d28e9b, 0xe5d5be0d, 0x7cdcefb7, 0x0bdbdf21,
    0x86d3d2d4, 0xf1d4e242, 0x68ddb3f8, 0x1fda836e, 0x81be16cd, 0xf6b9265b, 0x6fb077e1, 0x18b74777,
    0x88085ae6, 0xff0f6a70, 0x66063bca, 0x11010b5c, 0x8f659eff, 0xf862ae69, 0x616bffd3, 0x166ccf45,
    0xa00ae278, 0xd70dd2ee, 0x4e048354, 0x3903b3c2, 0xa7672661, 0xd06016f7, 0x4969474d, 0x3e6e77db,
    0xaed16a4a, 0xd9d65adc, 0x40df0b66, 0x37d83bf0, 0xa9bcae53, 0xdebb9ec5, 0x47b2cf7f, 0x30b5ffe9,
    0xbdbdf21c, 0xcabac28a, 0x53b39330, 0x24b4a3a6, 0xbad03605, 0xcdd70693, 0x54de5729, 0x23d967bf,
    0xb3667a2e, 0xc4614ab8, 0x5d681b02, 0x2a6f2b94, 0xb40bbe37, 0xc30c8ea1, 0x5a05df1b, 0x2d02ef8d
];
function $crc16(source, encoding) { return _crc(source, 0, __crcTable16, 0xffff, encoding) >>> 0; }
exports.$crc16 = $crc16;
function $crc32(source, encoding) { return (_crc(source, 0 ^ -1, __crcTable32, 0x00ffffff, encoding) ^ -1) >>> 0; }
exports.$crc32 = $crc32;
const __TSEncryptKeyLength = {
    'AES128': 16,
    'AES256': 32
};
const __TSEncryptAlgoRef = {
    'AES128': 'aes-128-cbc',
    'AES256': 'aes-256-cbc'
};
const __TSHashMethodRef = {
    'SHA256': 'sha256',
    'SHA384': 'sha384',
    'SHA512': 'sha512',
    'MD5': 'md5',
    'SHA1': 'sha1'
};
function _algo(algo) {
    const a = (0, strings_1.$trim)(algo).toUpperCase();
    return (0, commons_1.$ok)(__TSEncryptKeyLength[a]) ? a : exports.AES256;
}
function _createHash(method) { return crypto.createHash((0, commons_1.$value)(__TSHashMethodRef[(0, strings_1.$trim)(method).toUpperCase()], 'sha256')); }
function _charsetKeyAndAlgo(skey, opts) {
    const defaultCharset = tscharset_1.TSCharset.binaryCharset();
    const keyCharset = (0, tscharset_1.$charset)(opts === null || opts === void 0 ? void 0 : opts.keyEncoding, defaultCharset);
    const algo = _algo(opts === null || opts === void 0 ? void 0 : opts.algorithm);
    const isKeyObject = skey instanceof crypto.KeyObject;
    let key = isKeyObject ?
        skey :
        ((0, commons_1.$isstring)(skey) ?
            keyCharset.uint8ArrayFromString(skey) :
            (0, data_1.$uint8ArrayFromDataLike)(skey));
    if (!isKeyObject && key.length !== __TSEncryptKeyLength[algo]) {
        return [null, key, __TSEncryptAlgoRef[exports.AES256]];
    }
    return [(0, tscharset_1.$charset)(opts === null || opts === void 0 ? void 0 : opts.encoding, defaultCharset), key, __TSEncryptAlgoRef[algo]];
}
function $hash(buf, method, encoding) {
    let ret = null;
    try {
        const source = (0, commons_1.$isstring)(buf) ?
            (0, tscharset_1.$charset)(encoding, tscharset_1.TSCharset.binaryCharset()).uint8ArrayFromString(buf) :
            (0, data_1.$uint8ArrayFromDataLike)(buf);
        let hash = _createHash(method);
        hash.update(source);
        ret = hash.digest('hex');
    }
    catch (e) {
        ret = null;
    }
    return ret;
}
exports.$hash = $hash;
function $uuidhash(buf, version) {
    const v = (0, commons_1.$value)(version, types_1.UUIDv1);
    const h = $hash(buf, exports.MD5);
    if ((0, commons_1.$length)(h) === 32) {
        const s = h.toLowerCase();
        return s.slice(0, 8) + '-' + s.slice(8, 12)
            + (v === types_1.UUIDv1 ? '-' + s.slice(12, 16) + '-' + s.slice(16, 20)
                : '-4' + s.slice(13, 16) + '-' + _hnab(s.charAt(16)) + s.slice(17, 20))
            + '-' + s.slice(20, 32);
    }
    return null;
}
exports.$uuidhash = $uuidhash;
function $hashfile(filePath, method) {
    return __awaiter(this, void 0, void 0, function* () {
        return new Promise((resolve, reject) => {
            let hash = _createHash(method);
            if (!(0, commons_1.$length)(filePath)) {
                return reject(null);
            }
            try {
                (0, fs_1.createReadStream)(filePath).on('data', data => hash.update(data)).on('end', () => resolve(hash.digest('hex')));
            }
            catch (e) {
                return reject(null);
            }
        });
    });
}
exports.$hashfile = $hashfile;
;
function $random(max) {
    let m = (0, commons_1.$unsigned)(max);
    if (!m) {
        m = types_1.UINT32_MAX;
    }
    return crypto.randomInt(Math.min(m, types_1.UINT_MAX));
}
exports.$random = $random;
function $password(len, opts = { hasLowercase: true }) {
    const MAX_CONSECUTIVE_CHARS = 2;
    const rand = crypto.randomInt;
    if (!opts.hasLowercase && !opts.hasNumeric && !opts.hasSpecials && !opts.hasUppercase) {
        opts.hasUppercase = true;
    }
    if (len < 3 || len > 256)
        return null;
    let base = '';
    if (opts.hasLowercase) {
        base = base + "abcdefghijklmnopqrstuvwxyz";
    }
    if (opts.hasUppercase) {
        base = base + "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    }
    if (opts.hasNumeric) {
        base = base + "0123456789";
    }
    if (opts.hasLowercase && (rand(891) % 7)) {
        base = base + "abcdefghijklmnopqrstuvwxyz";
    }
    if (opts.hasLowercase) {
        base = base + "abcdefghijklmnopqrstuvwxyz";
    }
    if (opts.hasSpecials) {
        base = base + "!#$-_&*@()+/";
    }
    if (opts.hasSpecials && (rand(1795) % 3)) {
        base = base + "-#@*!";
    }
    if (opts.hasNumeric && (rand(733) % 2)) {
        base = base + "0123456789";
    }
    if (opts.hasNumeric) {
        base = base + "0123456789";
    }
    if (opts.hasLowercase) {
        base = base + "abcdefghijklmnopqrstuvwxyz";
    }
    const charlen = base.length;
    let identicals = 0, i = 0;
    let last = '', password = '';
    while (i < len) {
        let c = base.charAt(rand(charlen));
        if (c == last) {
            if (++identicals == MAX_CONSECUTIVE_CHARS) {
                identicals--;
            }
            else {
                password = password + c;
                i++;
            }
            ;
        }
        else {
            last = c;
            identicals = 0;
            password = password + c;
            i++;
        }
    }
    return password;
}
exports.$password = $password;
Uint8Array.prototype.crc16 = function crc16() { return $crc16(this); };
Uint8Array.prototype.crc32 = function crc32() { return $crc32(this); };
Uint8Array.prototype.hash = function hash(method) { return $hash(this, method); };
ArrayBuffer.prototype.crc16 = function crc16() { return $crc16(this); };
ArrayBuffer.prototype.crc32 = function crc32() { return $crc32(this); };
ArrayBuffer.prototype.hash = function hash(method) { return $hash(this, method); };
function _hnab(c) { return '89ab'.includes(c) ? c : '8'; }
function _crc(source, crc, table, andValue, encoding) {
    const src = (0, commons_1.$isstring)(source) ?
        (0, tscharset_1.$charset)(encoding, tscharset_1.TSCharset.binaryCharset()).uint8ArrayFromString(source) :
        (0, data_1.$uint8ArrayFromDataLike)(source);
    const len = src.length;
    for (let i = 0; i < len; i++) {
        crc = ((crc >> 8) & andValue) ^ table[(crc ^ src[i]) & 0xff];
    }
    return crc;
}
function _generateV4UUID(convertToLowerCase) {
    let uuid = "";
    for (let i = 0; i < 32; i++) {
        if (i === 12) {
            uuid += '-4';
        }
        else {
            if (i === 8 || i === 16 || i === 20) {
                uuid += '-';
            }
            const rand = crypto.randomInt(16) | 0;
            uuid += (i == 16 ? (rand & 3 | 8) : rand).toHex1(convertToLowerCase);
        }
    }
    return uuid;
}
//# sourceMappingURL=crypto.js.map